// --- [ dcf_bits.c ] ----------------------------------------------------------
//       23.10.09
//     schreibt und liest die DCF_Bits in einem Array von 8 Byte (= 64 Bits) 
//
// ----------------------------------------------------------------------------

#include <avr/io.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
#include "global.h"

uint8_t dcf_bits[8];			// lokale Variable fr 64 Bits
uint8_t bit_idx = 0;			// lokaler Zhler fr DCF-Bit-Nummer

// ----------------------------------------------------------------------------
// resetet alle Bits (kopiert sie vorher nach DCF_bits[]) 
// und (das ist das Wesentliche !) setzt den Index auf 0 zurck 
void DCF_reset_bits(void)
{
register uint8_t i = 8;		// Byte 7 .. 0 kopieren und dann lschen

do	{
	i--;
	time[BITS][i] = dcf_bits[i];// eine Kopie der Bits anlegen in globalem Array
	dcf_bits[i] = 0;			// Inhalt lschen
	} while (i); 
bit_idx = 0;					// den Index fr die nchste Minute zurcksetzen
}

// ----------------------------------------------------------------------------
// setzt den Bit-Wert von DCF_in in die nchste frei Bitposition
// incrementiert den Index bit_idx
// Rckgabe:  0 wenn kein Fehler 
//            wert = DCF_in, wenn mehr als 58 Impulse empfangen wurden

void DCF_save_bit(uint8_t v)
{
uint8_t i,j;

j = bit_idx / 8;			// das zustndige Byte aus dem Index ermitteln
i = bit_idx % 8;			// Bitposition
bit_idx++;					// Index auf die folgende Position setzen

if (v) dcf_bits[j] |= (1<<i); else dcf_bits[j] &= ~(1<<i);

} 

// ----------------------------------------------------------------------------
// holt in einem Array[. .31] das Bit x
uint8_t DCF_get_bit(uint8_t bit)
{
uint8_t i, j, r;

j = bit / 8;			// das zustndige Byte aus dem Index ermitteln
i = bit % 8;			// Bitposition

r = (dcf_bits[j] & (1<<i));
if (r) r = 1;
return(r);
}

/*
// ----------------------------------------------------------------------------
// setzt in einem Array[.. 31] das Bit x auf 1
void set_bit(uint8_t bit)
{
uint8_t i,j;

j = bit / 8;			// Byte
i = bit % 8;			// Bitposition

dcf_bits[j] |= (1<<i);
}

// ----------------------------------------------------------------------------
// lscht in einem Array[.. 31] das Bit x
void clear_bit(uint8_t bit)
{
uint8_t i,j;

j = bit / 8;			// Byte
i = bit % 8;			// Bitposition

dcf_bits[j] &= ~(1<<i);
} */


/*
// ----------------------------------------------------------------------------
// setzt in einem Array[.. 31] das Bit x auf 0 oder 1 (wenn value > 0)
void set_bit_value(uint8_t bit, uint8_t value)
{
uint8_t i,j;

j = bit / 8;			// Byte
i = bit % 8;			// Bitposition

if (value) dcf_bits[j] |= (1<<i); else dcf_bits[j] &= ~(1<<i);
}*/


/*
// ----------------------------------------------------------------------------
// schiebt alle Elemente des Arrays um 1 Bit nach rechts,
// bercksichtigt die bertrge von hheren zum niedrigeren Byte
// und fgt anschlieend DCF_in als Bit 58 ein.
void bits_shift_right(void)
{
uint8_t i;

for (i = 0; i < 7; i++)			// schiebt die ersten 7 Bytee
	{
	dcf_bits[i] /= 2;				// 7x nach rechts schieben
	if (dcf_bits[i+1] & 0x01) dcf_bits[i] += 0x80;
	i++;
	}

dcf_bits[7] /= 2;					// 8. Byte nach rechts schieben	
if (DCF_in) dcf_bits[7] += (0x04);	// Bit 58 = Byte 7, Bit 3 (7 * 8 - 1) + 3
} */


// --- [ eof ] ----------------------------------------------------------------